ublas: boost::numeric::ublas::vector_of_vector< T, L, A > Class Template Reference

# boost::numeric::ublas::vector_of_vector< T, L, A > Class Template Reference

A dense matrix of values of type `T` stored as a vector of vectors. More...

Inherits matrix_container< vector_of_vector< T, L, A > >.

List of all members.

## Classes
class | const_iterator1
class | const_iterator2
class | iterator1
class | iterator2
## Public Types
typedef A::size_type | size_type
typedef A::difference_type | difference_type
typedef T | value_type
typedef const T & | const_reference
typedef T & | reference
typedef A | array_type
typedef const matrix_reference < const self_type > | const_closure_type
typedef matrix_reference < self_type > | closure_type
typedef vector< T, typename A::value_type > | vector_temporary_type
typedef self_type | matrix_temporary_type
typedef dense_tag | storage_category
typedef L::orientation_category | orientation_category
typedef reverse_iterator_base1 < const_iterator1 > | const_reverse_iterator1
typedef reverse_iterator_base1 < iterator1 > | reverse_iterator1
typedef reverse_iterator_base2 < const_iterator2 > | const_reverse_iterator2
typedef reverse_iterator_base2 < iterator2 > | reverse_iterator2
## Public Member Functions
BOOST_UBLAS_INLINE | vector_of_vector (size_type size1, size_type size2)
BOOST_UBLAS_INLINE | vector_of_vector (const vector_of_vector &m)
template<class AE >
BOOST_UBLAS_INLINE | vector_of_vector (const matrix_expression< AE > &ae)
BOOST_UBLAS_INLINE size_type | size1 () const
BOOST_UBLAS_INLINE size_type | size2 () const
BOOST_UBLAS_INLINE const array_type & | data () const
BOOST_UBLAS_INLINE array_type & | data ()
BOOST_UBLAS_INLINE void | resize (size_type size1, size_type size2, bool preserve=true)
BOOST_UBLAS_INLINE const_reference | operator() (size_type i, size_type j) const
BOOST_UBLAS_INLINE reference | at_element (size_type i, size_type j)
BOOST_UBLAS_INLINE reference | operator() (size_type i, size_type j)
BOOST_UBLAS_INLINE reference | insert_element (size_type i, size_type j, const_reference t)
BOOST_UBLAS_INLINE void | erase_element (size_type i, size_type j)
BOOST_UBLAS_INLINE void | clear ()
BOOST_UBLAS_INLINE vector_of_vector & | operator= (const vector_of_vector &m)
BOOST_UBLAS_INLINE vector_of_vector & | assign_temporary (vector_of_vector &m)
template<class AE >
BOOST_UBLAS_INLINE vector_of_vector & | operator= (const matrix_expression< AE > &ae)
template<class C >
BOOST_UBLAS_INLINE vector_of_vector & | operator= (const matrix_container< C > &m)
template<class AE >
BOOST_UBLAS_INLINE vector_of_vector & | assign (const matrix_expression< AE > &ae)
template<class AE >
BOOST_UBLAS_INLINE vector_of_vector & | operator+= (const matrix_expression< AE > &ae)
template<class C >
BOOST_UBLAS_INLINE vector_of_vector & | operator+= (const matrix_container< C > &m)
template<class AE >
BOOST_UBLAS_INLINE vector_of_vector & | plus_assign (const matrix_expression< AE > &ae)
template<class AE >
BOOST_UBLAS_INLINE vector_of_vector & | operator-= (const matrix_expression< AE > &ae)
template<class C >
BOOST_UBLAS_INLINE vector_of_vector & | operator-= (const matrix_container< C > &m)
template<class AE >
BOOST_UBLAS_INLINE vector_of_vector & | minus_assign (const matrix_expression< AE > &ae)
template<class AT >
BOOST_UBLAS_INLINE vector_of_vector & | operator*= (const AT &at)
template<class AT >
BOOST_UBLAS_INLINE vector_of_vector & | operator/= (const AT &at)
BOOST_UBLAS_INLINE void | swap (vector_of_vector &m)
BOOST_UBLAS_INLINE const_iterator1 | find1 (int, size_type i, size_type j) const
BOOST_UBLAS_INLINE iterator1 | find1 (int, size_type i, size_type j)
BOOST_UBLAS_INLINE const_iterator2 | find2 (int, size_type i, size_type j) const
BOOST_UBLAS_INLINE iterator2 | find2 (int, size_type i, size_type j)
BOOST_UBLAS_INLINE const_iterator1 | begin1 () const
BOOST_UBLAS_INLINE const_iterator1 | end1 () const
BOOST_UBLAS_INLINE iterator1 | begin1 ()
BOOST_UBLAS_INLINE iterator1 | end1 ()
BOOST_UBLAS_INLINE const_iterator2 | begin2 () const
BOOST_UBLAS_INLINE const_iterator2 | end2 () const
BOOST_UBLAS_INLINE iterator2 | begin2 ()
BOOST_UBLAS_INLINE iterator2 | end2 ()
BOOST_UBLAS_INLINE const_reverse_iterator1 | rbegin1 () const
BOOST_UBLAS_INLINE const_reverse_iterator1 | rend1 () const
BOOST_UBLAS_INLINE reverse_iterator1 | rbegin1 ()
BOOST_UBLAS_INLINE reverse_iterator1 | rend1 ()
BOOST_UBLAS_INLINE const_reverse_iterator2 | rbegin2 () const
BOOST_UBLAS_INLINE const_reverse_iterator2 | rend2 () const
BOOST_UBLAS_INLINE reverse_iterator2 | rbegin2 ()
BOOST_UBLAS_INLINE reverse_iterator2 | rend2 ()
template<class Archive >
void | serialize (Archive &ar, const unsigned int)
## Friends
BOOST_UBLAS_INLINE friend void | swap (vector_of_vector &m1, vector_of_vector &m2)

## Detailed Description

### template<class T, class L, class A>
class boost::numeric::ublas::vector_of_vector< T, L, A >

Rows or columns are not stored into contiguous chunks of memory but data inside rows (or columns) are. Orientation and storage can also be specified, otherwise a row major and unbounded arrays are used. The data is stored as a vector of vectors, meaning that rows or columns might not be stored into contiguous chunks of memory. Orientation and storage can also be specified, otherwise a row major and unbounded arrays are used. The storage type defaults to `unbounded_array<unbounded_array<T>>` and orientation is `row_major`. It is not required by the storage to initialize elements of the matrix. For a -dimensional matrix and , every element is mapped to the -th element of the container for row major orientation or the -th element of the container for column major orientation.

Template Parameters:

  | T | the type of object stored in the matrix (like double, float, complex, etc...)
  | L | the storage organization. It can be either `row_major` or `column_major`. By default it is `row_major`
  | A | the type of Storage array. By default, it is an <unbounder_array<T>>